package org.jk.rag.service;

import org.jk.common.mybatis.core.page.TableDataInfo;
import org.jk.common.mybatis.core.page.PageQuery;
import org.jk.rag.domain.bo.ModelConfigBo;
import org.jk.rag.domain.dto.ConfigReqDTO;
import org.jk.rag.domain.vo.ModelConfigVo;

import java.util.Collection;
import java.util.List;

/**
 * 模型配置Service接口
 *
 * @author Lion Li
 * @date 2026-01-19
 */
public interface IModelConfigService {

    /**
     * 查询模型配置
     *
     * @param id 主键
     * @return 模型配置
     */
    ModelConfigVo queryById(Long id);

    /**
     * 分页查询模型配置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 模型配置分页列表
     */
    TableDataInfo<ModelConfigVo> queryPageList(ModelConfigBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的模型配置列表
     *
     * @param bo 查询条件
     * @return 模型配置列表
     */
    List<ModelConfigVo> queryList(ModelConfigBo bo);

    /**
     * 新增模型配置
     *
     * @param bo 模型配置
     * @return 是否新增成功
     */
    Boolean insertByBo(ModelConfigBo bo);

    /**
     * 修改模型配置
     *
     * @param bo 模型配置
     * @return 是否修改成功
     */
    Boolean updateByBo(ModelConfigBo bo);

    /**
     * 校验并批量删除模型配置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    List<ModelConfigVo> queryRerankList(ModelConfigBo bo);

    List<ModelConfigVo> queryModelList(ModelConfigBo bo);

    int updateStatus(Long id);

    ConfigReqDTO queryConfig();

    void editSysConfig(ModelConfigBo bo);
}
